import { system, BlockPermutation, world } from "@minecraft/server";
import 'on_interact_blocks'
import 'on_random_tick_blocks'
import 'on_destroy_blocks'
import 'on_place_blocks'
import 'entity_functions'
import 'use_items'
import 'custom_block_and_tool_integrated_durability'
import { fence_Manager } from 'fences/fence_Manager'

//Function Fence
world.afterEvents.playerBreakBlock.subscribe((data) => {
    fence_Manager.updateFencesAround(data.block)
})

world.afterEvents.playerPlaceBlock.subscribe((data) => {
    fence_Manager.updateFencesAround(data.block)
})