import { world, BlockPermutation, ItemStack } from '@minecraft/server';

//FENCE GATES

//Black Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_black_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:black_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Blue Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_blue_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:blue_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Brown Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_brown_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:brown_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Cyan Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_cyan_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:cyan_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Dark Green Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_dark_green_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:dark_green_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Dark Purple Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_dark_purple_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:dark_purple_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Green Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_green_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:green_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Grey Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_grey_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:grey_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Light Blue Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_light_blue_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:light_blue_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Light Grey Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_light_grey_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:light_grey_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Pink Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_pink_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:pink_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Orange Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_orange_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:orange_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Purple Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_purple_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:purple_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Red Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_red_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:red_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//White Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_white_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:white_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

//Yellow Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_yellow_fence_gate', {
        onPlayerDestroy(e) {
            const { block } = e;
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:yellow_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                aboveBlock.setType('minecraft:air')
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_jade_block', {
        onPlayerDestroy({ block, player }) {
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.hasTag('minecraft:is_pickaxe')) {
                block.dimension.spawnItem(new ItemStack('old_villagers_plus:jade_block', 1), block.location);
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_jade_ore', {
        onPlayerDestroy({ block, player }) {
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.hasTag('minecraft:is_pickaxe')) {
                block.dimension.spawnEntity(('old_villagers_plus:jade_ore_loot'), block.location);
                block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
                block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
                block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_destroy_crystal_heart_ore', {
        onPlayerDestroy({ block, player }) {
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.hasTag('minecraft:is_pickaxe')) {
                block.dimension.spawnEntity(('old_villagers_plus:crystal_heart_ore_loot'), block.location);
                block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
                block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
                block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            }
        }
    });
});